Generalize filesystem location variables (closes http://web.monkeysphere.info/bugs...
[monkeysphere.git] / src / monkeysphere-server
index d70fe93e5d6313d697db85adc950fae714bf74ee..324a27351f24fb5916215d6c174ce0061ef04300 100755 (executable)
@@ -1,9 +1,11 @@
-#!/bin/bash
+#!/usr/bin/env bash
 
 # monkeysphere-server: MonkeySphere server admin tool
 #
 # The monkeysphere scripts are written by:
 # Jameson Rollins <jrollins@fifthhorseman.net>
+# Jamie McClelland <jm@mayfirst.org>
+# Daniel Kahn Gillmor <dkg@fifthhorseman.net>
 #
 # They are Copyright 2008, and are all released under the GPL, version 3
 # or later.
 ########################################################################
 PGRM=$(basename $0)
 
-SHARE=${MONKEYSPHERE_SHARE:="/usr/share/monkeysphere"}
-export SHARE
-. "${SHARE}/common" || exit 1
+SYSSHAREDIR=${MONKEYSPHERE_SYSSHAREDIR:-"/usr/share/monkeysphere"}
+export SYSSHAREDIR
+. "${SYSSHAREDIR}/common" || exit 1
 
-VARLIB="/var/lib/monkeysphere"
-export VARLIB
+SYSDATADIR=${MONKEYSPHERE_SYSDATADIR:-"/var/lib/monkeysphere"
+export SYSDATADIR
 
-# date in UTF format if needed
+# UTC date in ISO 8601 format if needed
 DATE=$(date -u '+%FT%T')
 
 # unset some environment variables that could screw things up
@@ -32,36 +34,40 @@ RETURN=0
 ########################################################################
 
 usage() {
-cat <<EOF
+    cat <<EOF >&2
 usage: $PGRM <subcommand> [options] [args]
-MonkeySphere server admin tool.
+Monkeysphere server admin tool.
 
 subcommands:
  update-users (u) [USER]...          update user authorized_keys files
 
- gen-key (g) [HOSTNAME]              generate gpg key for the server
-   -l|--length BITS                    key length in bits (2048)
-   -e|--expire EXPIRE                  date to expire
-   -r|--revoker FINGERPRINT            add a revoker
- show-fingerprint (f)                show server's host key fingerprint
- publish-key (p)                     publish server's host key to keyserver
- diagnostics (d)                     report on the server's monkeysphere status
-
- add-identity-certifier (a) KEYID    import and tsign a certification key
-   -n|--domain DOMAIN                  limit ID certifications to IDs in DOMAIN
-   -t|--trust TRUST                    trust level of certifier (full)
-   -d|--depth DEPTH                    trust depth for certifier (1)
- remove-identity-certifier (r) KEYID remove a certification key
- list-identity-certifiers (l)        list certification keys
+ gen-key (g) [NAME[:PORT]]           generate gpg key for the server
+   --length (-l) BITS                  key length in bits (2048)
+   --expire (-e) EXPIRE                date to expire
+   --revoker (-r) FINGERPRINT          add a revoker
+ extend-key (e) EXPIRE               extend expiration to EXPIRE
+ add-hostname (n+) NAME[:PORT]       add hostname user ID to server key
+ revoke-hostname (n-) NAME[:PORT]    revoke hostname user ID
+ show-key (s)                        output all server host key information
+ publish-key (p)                     publish server host key to keyserver
+ diagnostics (d)                     report on server monkeysphere status
+
+ add-id-certifier (c+) KEYID         import and tsign a certification key
+   --domain (-n) DOMAIN                limit ID certifications to DOMAIN
+   --trust (-t) TRUST                  trust level of certifier (full)
+   --depth (-d) DEPTH                  trust depth for certifier (1)
+ remove-id-certifier (c-) KEYID      remove a certification key
+ list-id-certifiers (c)              list certification keys
 
  gpg-authentication-cmd CMD          gnupg-authentication command
 
  help (h,?)                          this help
+
 EOF
 }
 
 su_monkeysphere_user() {
-    su --preserve-environment "$MONKEYSPHERE_USER" -- -c "$@"
+    su "$MONKEYSPHERE_USER" -c "$@"
 }
 
 # function to interact with the host gnupg keyring
@@ -97,6 +103,32 @@ gpg_authentication() {
     su_monkeysphere_user "gpg $@"
 }
 
+# output just key fingerprint
+fingerprint_server_key() {
+    gpg_host --list-secret-keys --fingerprint \
+       --with-colons --fixed-list-mode 2> /dev/null | \
+       grep '^fpr:' | head -1 | cut -d: -f10
+}
+
+# output key information
+show_server_key() {
+    local fingerprint
+    local tmpkey
+
+    fingerprint=$(fingerprint_server_key)
+    gpg_authentication "--fingerprint --list-key --list-options show-unusable-uids $fingerprint"
+
+    # dumping to a file named ' ' so that the ssh-keygen output
+    # doesn't claim any potentially bogus hostname(s):
+    tmpkey=$(mktemp -d ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
+    gpg_authentication "--export $fingerprint" | openpgp2ssh "$fingerprint" 2>/dev/null > "$tmpkey/ "
+    echo -n "ssh fingerprint: "
+    (cd "$tmpkey" && ssh-keygen -l -f ' ' | awk '{ print $2 }')
+    rm -rf "$tmpkey"
+    echo -n "OpenPGP fingerprint: "
+    echo "$fingerprint"
+}
+
 # update authorized_keys for users
 update_users() {
     if [ "$1" ] ; then
@@ -119,13 +151,13 @@ update_users() {
     fi
 
     # make sure the authorized_keys directory exists
-    mkdir -p "${VARLIB}/authorized_keys"
+    mkdir -p "${SYSDATADIR}/authorized_keys"
 
     # loop over users
     for uname in $unames ; do
        # check all specified users exist
        if ! getent passwd "$uname" >/dev/null ; then
-           log "----- unknown user '$uname' -----"
+           log error "----- unknown user '$uname' -----"
            continue
        fi
 
@@ -141,40 +173,40 @@ update_users() {
            fi
        fi
 
-       log "----- user: $uname -----"
+       log verbose "----- user: $uname -----"
 
         # exit if the authorized_user_ids file is empty
        if ! check_key_file_permissions "$uname" "$AUTHORIZED_USER_IDS" ; then
-           log "Improper permissions on authorized_user_ids file path."
+           log error "Improper permissions on path '$AUTHORIZED_USER_IDS'."
            continue
        fi
 
        # check permissions on the authorized_keys file path
        if ! check_key_file_permissions "$uname" "$RAW_AUTHORIZED_KEYS" ; then
-           log "Improper permissions on authorized_keys file path path."
+           log error "Improper permissions on path '$RAW_AUTHORIZED_KEYS'."
            continue
        fi
 
         # make temporary directory
-        TMPDIR=$(mktemp -d)
+        TMPLOC=$(mktemp -d ${TMPDIR:-/tmp}/tmp.XXXXXXXXXX)
 
        # trap to delete temporary directory on exit
-       trap "rm -rf $TMPDIR" EXIT
+       trap "rm -rf $TMPLOC" EXIT
 
         # create temporary authorized_user_ids file
-        TMP_AUTHORIZED_USER_IDS="${TMPDIR}/authorized_user_ids"
+        TMP_AUTHORIZED_USER_IDS="${TMPLOC}/authorized_user_ids"
         touch "$TMP_AUTHORIZED_USER_IDS"
 
         # create temporary authorized_keys file
-        AUTHORIZED_KEYS="${TMPDIR}/authorized_keys"
+        AUTHORIZED_KEYS="${TMPLOC}/authorized_keys"
         touch "$AUTHORIZED_KEYS"
 
         # set restrictive permissions on the temporary files
        # FIXME: is there a better way to do this?
-        chmod 0700 "$TMPDIR"
+        chmod 0700 "$TMPLOC"
         chmod 0600 "$AUTHORIZED_KEYS"
         chmod 0600 "$TMP_AUTHORIZED_USER_IDS"
-        chown -R "$MONKEYSPHERE_USER" "$TMPDIR"
+        chown -R "$MONKEYSPHERE_USER" "$TMPLOC"
 
        # if the authorized_user_ids file exists...
        if [ -s "$authorizedUserIDs" ] ; then
@@ -189,15 +221,14 @@ update_users() {
            # process authorized_user_ids file, as monkeysphere
            # user
            su_monkeysphere_user \
-               ". ${SHARE}/common; process_authorized_user_ids $TMP_AUTHORIZED_USER_IDS"
+               ". ${SYSSHAREDIR}/common; process_authorized_user_ids $TMP_AUTHORIZED_USER_IDS"
            RETURN="$?"
        fi
 
        # add user-controlled authorized_keys file path if specified
        if [ "$rawAuthorizedKeys" != '-' -a -s "$rawAuthorizedKeys" ] ; then
-           log -n "adding raw authorized_keys file... "
+           log verbose "adding raw authorized_keys file... "
            cat "$rawAuthorizedKeys" >> "$AUTHORIZED_KEYS"
-           loge "done."
        fi
 
        # openssh appears to check the contents of the
@@ -209,10 +240,10 @@ update_users() {
        chmod g+r "$AUTHORIZED_KEYS"
 
        # move the resulting authorized_keys file into place
-       mv -f "$AUTHORIZED_KEYS" "${VARLIB}/authorized_keys/${uname}"
+       mv -f "$AUTHORIZED_KEYS" "${SYSDATADIR}/authorized_keys/${uname}"
 
        # destroy temporary directory
-       rm -rf "$TMPDIR"
+       rm -rf "$TMPLOC"
     done
 }
 
@@ -236,7 +267,7 @@ gen_key() {
     revoker=
 
     # get options
-    TEMP=$(getopt -o l:e:r: -l length:,expire:,revoker: -n "$PGRM" -- "$@")
+    TEMP=$(PATH="/usr/local/bin:$PATH" getopt -o e:l:r -l expire:,length:,revoker: -n "$PGRM" -- "$@") || failure "getopt failed!  Does your getopt support GNU-style long options?"
 
     if [ $? != 0 ] ; then
        exit 1
@@ -268,7 +299,7 @@ gen_key() {
        esac
     done
 
-    hostName=${1:-$(hostname --fqdn)}
+    hostName=${1:-$(hostname -f)}
     userID="ssh://${hostName}"
 
     # check for presense of key with user ID
@@ -277,25 +308,7 @@ gen_key() {
     fi
 
     # prompt about key expiration if not specified
-    if [ -z "$keyExpire" ] ; then
-       cat <<EOF
-Please specify how long the key should be valid.
-         0 = key does not expire
-      <n>  = key expires in n days
-      <n>w = key expires in n weeks
-      <n>m = key expires in n months
-      <n>y = key expires in n years
-EOF
-       while [ -z "$keyExpire" ] ; do
-           read -p "Key is valid for? (0) " keyExpire
-           if ! test_gpg_expire ${keyExpire:=0} ; then
-               echo "invalid value"
-               unset keyExpire
-           fi
-       done
-    elif ! test_gpg_expire "$keyExpire" ; then
-       failure "invalid key expiration value '$keyExpire'."
-    fi
+    keyExpire=$(get_gpg_expiration "$keyExpire")
 
     # set key parameters
     keyParameters=$(cat <<EOF
@@ -333,18 +346,17 @@ EOF
 EOF
 )
 
-    log "generating server key..."
+    log verbose "generating server key..."
     echo "$keyParameters" | gpg_host --batch --gen-key
 
     # output the server fingerprint
     fingerprint_server_key "=${userID}"
 
-    # find the key fingerprint of the server primary key
-    fingerprint=$(gpg_host --list-key --with-colons --with-fingerprint "=${userID}" | \
-       grep '^fpr:' | head -1 | cut -d: -f10)
+    # find the key fingerprint of the newly generated key
+    fingerprint=$(fingerprint_server_key)
 
     # export host ownertrust to authentication keyring
-    log "setting ultimate owner trust for server key..."
+    log verbose "setting ultimate owner trust for server key..."
     echo "${fingerprint}:6:" | gpg_authentication "--import-ownertrust"
 
     # translate the private key to ssh format, and export to a file
@@ -352,113 +364,312 @@ EOF
     # NOTE: assumes that the primary key is the proper key to use
     (umask 077 && \
        gpg_host --export-secret-key "$fingerprint" | \
-       openpgp2ssh "$fingerprint" > "${VARLIB}/ssh_host_rsa_key")
-    log "Private SSH host key output to file: ${VARLIB}/ssh_host_rsa_key"
+       openpgp2ssh "$fingerprint" > "${SYSDATADIR}/ssh_host_rsa_key")
+    log info "Private SSH host key output to file: ${SYSDATADIR}/ssh_host_rsa_key"
 }
 
-# gpg output key fingerprint
-fingerprint_server_key() {
-    gpg_host --fingerprint --list-secret-keys
+# extend the lifetime of a host key:
+extend_key() {
+    local fpr=$(fingerprint_server_key)
+    local extendTo="$1"
+
+    if [ -z "$fpr" ] ; then
+       failure "You don't appear to have a MonkeySphere host key on this server.  Try 'monkeysphere-server gen-key' first."
+    fi
+
+    # get the new expiration date
+    extendTo=$(get_gpg_expiration "$extendTo")
+
+    gpg_host --quiet --command-fd 0 --edit-key "$fpr" <<EOF 
+expire
+$extendTo
+save
+EOF
+
+    echo
+    echo "NOTE: Host key expiration date adjusted, but not yet published."
+    echo "Run '$PGRM publish-key' to publish the new expiration date."
+}
+
+# add hostname user ID to server key
+add_hostname() {
+    local userID
+    local fingerprint
+    local tmpuidMatch
+    local line
+    local adduidCommand
+
+    if [ -z "$1" ] ; then
+       failure "You must specify a hostname to add."
+    fi
+
+    userID="ssh://${1}"
+
+    fingerprint=$(fingerprint_server_key)
+
+    # match to only ultimately trusted user IDs
+    tmpuidMatch="u:$(echo $userID | gpg_escape)"
+
+    # find the index of the requsted user ID
+    # NOTE: this is based on circumstantial evidence that the order of
+    # this output is the appropriate index
+    if line=$(gpg_host --list-keys --with-colons --fixed-list-mode "0x${fingerprint}!" \
+       | egrep '^(uid|uat):' | cut -f2,10 -d: | grep -n -x -F "$tmpuidMatch") ; then
+       failure "Host userID '$userID' already exists."
+    fi
+
+    echo "The following user ID will be added to the host key:"
+    echo "  $userID"
+    read -p "Are you sure you would like to add this user ID? (y/N) " OK; OK=${OK:=N}
+    if [ ${OK/y/Y} != 'Y' ] ; then
+       failure "User ID not added."
+    fi
+
+    # edit-key script command to add user ID
+    adduidCommand=$(cat <<EOF
+adduid
+$userID
+
+
+save
+EOF
+       )
+
+    # execute edit-key script
+    if echo "$adduidCommand" | \
+       gpg_host --quiet --command-fd 0 --edit-key "0x${fingerprint}!" ; then
+
+        # update the trustdb for the authentication keyring
+       gpg_authentication "--check-trustdb"
+
+       show_server_key
+
+       echo
+       echo "NOTE: User ID added to key, but key not published."
+       echo "Run '$PGRM publish-key' to publish the new user ID."
+    else
+       failure "Problem adding user ID."
+    fi
+}
+
+# revoke hostname user ID to server key
+revoke_hostname() {
+    local userID
+    local fingerprint
+    local tmpuidMatch
+    local line
+    local uidIndex
+    local message
+    local revuidCommand
+
+    if [ -z "$1" ] ; then
+       failure "You must specify a hostname to revoke."
+    fi
+
+    echo "WARNING: There is a known bug in this function."
+    echo "This function has been known to occasionally revoke the wrong user ID."
+    echo "Please see the following bug report for more information:"
+    echo "http://web.monkeysphere.info/bugs/revoke-hostname-revoking-wrong-userid/"
+    read -p "Are you sure you would like to proceed? (y/N) " OK; OK=${OK:=N}
+    if [ ${OK/y/Y} != 'Y' ] ; then
+       failure "aborting."
+    fi
+
+    userID="ssh://${1}"
+
+    fingerprint=$(fingerprint_server_key)
+
+    # match to only ultimately trusted user IDs
+    tmpuidMatch="u:$(echo $userID | gpg_escape)"
+
+    # find the index of the requsted user ID
+    # NOTE: this is based on circumstantial evidence that the order of
+    # this output is the appropriate index
+    if line=$(gpg_host --list-keys --with-colons --fixed-list-mode "0x${fingerprint}!" \
+       | egrep '^(uid|uat):' | cut -f2,10 -d: | grep -n -x -F "$tmpuidMatch") ; then
+       uidIndex=${line%%:*}
+    else
+       failure "No non-revoked user ID '$userID' is found."
+    fi
+
+    echo "The following host key user ID will be revoked:"
+    echo "  $userID"
+    read -p "Are you sure you would like to revoke this user ID? (y/N) " OK; OK=${OK:=N}
+    if [ ${OK/y/Y} != 'Y' ] ; then
+       failure "User ID not revoked."
+    fi
+
+    message="Hostname removed by monkeysphere-server $DATE"
+
+    # edit-key script command to revoke user ID
+    revuidCommand=$(cat <<EOF
+$uidIndex
+revuid
+y
+4
+$message
+
+y
+save
+EOF
+       )       
+
+    # execute edit-key script
+    if echo "$revuidCommand" | \
+       gpg_host --quiet --command-fd 0 --edit-key "0x${fingerprint}!" ; then
+
+        # update the trustdb for the authentication keyring
+       gpg_authentication "--check-trustdb"
+
+       show_server_key
+
+       echo
+       echo "NOTE: User ID revoked, but revocation not published."
+       echo "Run '$PGRM publish-key' to publish the revocation."
+    else
+       failure "Problem revoking user ID."
+    fi
 }
 
 # publish server key to keyserver
 publish_server_key() {
-    read -p "Really publish key to $KEYSERVER? (y/N) " OK; OK=${OK:=N}
+    read -p "Really publish host key to $KEYSERVER? (y/N) " OK; OK=${OK:=N}
     if [ ${OK/y/Y} != 'Y' ] ; then
-       failure "aborting."
+       failure "key not published."
     fi
 
+    # find the key fingerprint
+    fingerprint=$(fingerprint_server_key)
+
     # publish host key
-    # FIXME: need to figure out better way to identify host key
-    # dummy command so as not to publish fakes keys during testing
-    # eventually:
-    #gpg_authentication "--keyserver $KEYSERVER --send-keys $(hostname -f)"
-    echo "NOT PUBLISHED (to avoid permanent publication errors during monkeysphere development)."
-    echo "The following command should publish the key:"
-    echo "monkeysphere-server gpg-authentication-cmd '--keyserver $KEYSERVER --send-keys $(hostname -f)'"
-    exit 255
+    gpg_authentication "--keyserver $KEYSERVER --send-keys '0x${fingerprint}!'"
 }
 
+
 diagnostics() {
 #  * check on the status and validity of the key and public certificates
     local seckey
     local keysfound
-    local keyexp
     local curdate
     local warnwindow
     local warndate
+    local create
+    local expire
+    local uid
+    local fingerprint
+    local badhostkeys
+    local sshd_config
+    local problemsfound=0
 
-    seckey=$(gpg_host --list-secret-keys --with-colons --fixed-list-mode)
+    # FIXME: what's the correct, cross-platform answer?
+    sshd_config=/etc/ssh/sshd_config
+    seckey=$(gpg_host --list-secret-keys --fingerprint --with-colons --fixed-list-mode)
     keysfound=$(echo "$seckey" | grep -c ^sec:)
     curdate=$(date +%s)
     # warn when anything is 2 months away from expiration
     warnwindow='2 months'
-    warndate=$(date +%s -d "$warnwindow")
+    warndate=$(advance_date $warnwindow +%s)
+
+    if ! id monkeysphere >/dev/null ; then
+       echo "! No monkeysphere user found!  Please create a monkeysphere system user with bash as its shell."
+       problemsfound=$(($problemsfound+1))
+    fi
 
+    if ! [ -d "$SYSDATADIR" ] ; then
+       echo "! no $SYSDATADIR directory found.  Please create it."
+       problemsfound=$(($problemsfound+1))
+    fi
+
+    echo "Checking host GPG key..."
     if (( "$keysfound" < 1 )); then
-       echo "No host key found!"
-       echo "Recommendation: run 'monkeysphere-server gen-key'"
+       echo "! No host key found."
+       echo " - Recommendation: run 'monkeysphere-server gen-key'"
+       problemsfound=$(($problemsfound+1))
+    elif (( "$keysfound" > 1 )); then
+       echo "! More than one host key found?"
+       # FIXME: recommend a way to resolve this
+       problemsfound=$(($problemsfound+1))
     else
-       if (( "$keysfound" > 1 )); then
-           echo "more than one host key found?"
-       else
+       create=$(echo "$seckey" | grep ^sec: | cut -f6 -d:)
+       expire=$(echo "$seckey" | grep ^sec: | cut -f7 -d:)
+       fingerprint=$(echo "$seckey" | grep ^fpr: | head -n1 | cut -f10 -d:)
        # check for key expiration:
-           keyexp=$(echo "$seckey" | grep ^sec: | cut -f7 -d:)
-           if (( "$keyexp"  < "$curdate" )); then
-               echo "Host key is expired!"
-               # FIXME: recommend a way to resolve this other than re-keying?
-           elif (( "$keyexp" < "$warndate" )); then
-               echo "Host key expires in less than $warnwindow"
-               # FIXME: recommend a way to resolve this?
+       if [ "$expire" ]; then
+           if (( "$expire"  < "$curdate" )); then
+               echo "! Host key is expired."
+               echo " - Recommendation: extend lifetime of key with 'monkeysphere-server extend-key'"
+               problemsfound=$(($problemsfound+1))
+           elif (( "$expire" < "$warndate" )); then
+               echo "! Host key expires in less than $warnwindow:" $(advance_date $(( $expire - $curdate )) seconds +%F)
+               echo " - Recommendation: extend lifetime of key with 'monkeysphere-server extend-key'"
+               problemsfound=$(($problemsfound+1))
            fi
+       fi
+
         # and weirdnesses:
-           if (( $(echo "$seckey" | grep ^sec: | cut -f6 -d:) > "$curdate" )); then
-               echo "Host key was created in the future(?!). Is your clock correct?"
-               echo "Recommendation: Check clock ($(date +%F_%T)); use NTP?"
-           fi
+       if [ "$create" ] && (( "$create" > "$curdate" )); then
+           echo "! Host key was created in the future(?!). Is your clock correct?"
+           echo " - Recommendation: Check clock ($(date +%F_%T)); use NTP?"
+           problemsfound=$(($problemsfound+1))
+       fi
 
         # check for UserID expiration:
-           echo "$seckey" | grep ^uid: | cut -d: -f6,7,10 | \
-           while IFS=: read create expire uid ; do
-               # FIXME: should we be doing any checking on the form
-               # of the User ID?  Should we be unmangling it somehow?
-               if [ "$create" ] && (( "$create" > "$curdate" )); then
-                   echo "User ID '$uid' was created in the future(?!).  Is your clock correct?"
-                   echo "Recommendation: Check clock ($(date +%F_%T)); use NTP?"
-               fi
-               if [ "$expire" ] ; then
-                   if (( "$expire" < "$curdate" )); then
-                       echo "User ID '$uid' is expired!"
-                       # FIXME: recommend a way to resolve this
-                   elif (( "$expire" < "$warndate" )); then
-                       echo "User ID '$uid' expires in less than $warnwindow"
-                       # FIXME: recommend a way to resolve this
-                   fi
+       echo "$seckey" | grep ^uid: | cut -d: -f6,7,10 | \
+       while IFS=: read create expire uid ; do
+           # FIXME: should we be doing any checking on the form
+           # of the User ID?  Should we be unmangling it somehow?
+
+           if [ "$create" ] && (( "$create" > "$curdate" )); then
+               echo "! User ID '$uid' was created in the future(?!).  Is your clock correct?"
+               echo " - Recommendation: Check clock ($(date +%F_%T)); use NTP?"
+               problemsfound=$(($problemsfound+1))
+           fi
+           if [ "$expire" ] ; then
+               if (( "$expire" < "$curdate" )); then
+                   echo "! User ID '$uid' is expired."
+                   # FIXME: recommend a way to resolve this
+                   problemsfound=$(($problemsfound+1))
+               elif (( "$expire" < "$warndate" )); then
+                   echo "! User ID '$uid' expires in less than $warnwindow:" $(advance_date $(( $expire - $curdate )) seconds +%F)             
+                   # FIXME: recommend a way to resolve this
+                   problemsfound=$(($problemsfound+1))
                fi
-           done
+           fi
+       done
            
 # FIXME: verify that the host key is properly published to the
-#   keyservers
+#   keyservers (do this with the non-privileged user)
 
 # FIXME: check that there are valid, non-expired certifying signatures
-#   attached to the host key
+#   attached to the host key after fetching from the public keyserver
+#   (do this with the non-privileged user as well)
 
 # FIXME: propose adding a revoker to the host key if none exist (do we
 #   have a way to do that after key generation?)
 
-# Ensure that the ssh_host_rsa_key file is present and non-empty:
-           if [ ! -s "${VARLIB}/ssh_host_rsa_key" ] ; then
-               echo "The host key as prepared for SSH (${VARLIB}/ssh_host_rsa_key) is missing or empty!"
-           else
-               if [ $(stat -c "${VARLIB}/ssh_host_rsa_key") != 600 ] ; then
-                   echo "Permissions seem wrong for ${VARLIB}/ssh_host_rsa_key -- should be 0600 !"
-               fi
+       # Ensure that the ssh_host_rsa_key file is present and non-empty:
+       echo
+       echo "Checking host SSH key..."
+       if [ ! -s "${SYSDATADIR}/ssh_host_rsa_key" ] ; then
+           echo "! The host key as prepared for SSH (${SYSDATADIR}/ssh_host_rsa_key) is missing or empty."
+           problemsfound=$(($problemsfound+1))
+       else
+           if [ $(ls -l "${SYSDATADIR}/ssh_host_rsa_key" | cut -f1 -d\ ) != '-rw-------' ] ; then
+               echo "! Permissions seem wrong for ${SYSDATADIR}/ssh_host_rsa_key -- should be 0600."
+               problemsfound=$(($problemsfound+1))
+           fi
 
-               # propose changes needed for sshd_config (if any)
-               if ! grep -q "^HostKey ${VARLIB}/ssh_host_rsa_key$" /etc/ssh/sshd_config; then
-                   echo "/etc/ssh/sshd_config does not point to the monkeysphere host key (${VARLIB}/ssh_host_rsa_key)."
-                   echo "Recommendation: add a line to /etc/ssh/sshd_config: 'HostKey ${VARLIB}/ssh_host_rsa_key'"
-               fi
+           # propose changes needed for sshd_config (if any)
+           if ! grep -q "^HostKey[[:space:]]\+${SYSDATADIR}/ssh_host_rsa_key$" "$sshd_config"; then
+               echo "! $sshd_config does not point to the monkeysphere host key (${SYSDATADIR}/ssh_host_rsa_key)."
+               echo " - Recommendation: add a line to $sshd_config: 'HostKey ${SYSDATADIR}/ssh_host_rsa_key'"
+               problemsfound=$(($problemsfound+1))
+           fi
+           if badhostkeys=$(grep -i '^HostKey' "$sshd_config" | grep -v "^HostKey[[:space:]]\+${SYSDATADIR}/ssh_host_rsa_key$") ; then
+               echo "! $sshd_config refers to some non-monkeysphere host keys:"
+               echo "$badhostkeys"
+               echo " - Recommendation: remove the above HostKey lines from $sshd_config"
+               problemsfound=$(($problemsfound+1))
            fi
        fi
     fi
@@ -472,6 +683,30 @@ diagnostics() {
 
 # FIXME:  make sure that at least one identity certifier exists
 
+# FIXME: look at the timestamps on the monkeysphere-generated
+# authorized_keys files -- warn if they seem out-of-date.
+
+    echo
+    echo "Checking for MonkeySphere-enabled public-key authentication for users ..."
+    # Ensure that User ID authentication is enabled:
+    if ! grep -q "^AuthorizedKeysFile[[:space:]]\+${SYSDATADIR}/authorized_keys/%u$" "$sshd_config"; then
+       echo "! $sshd_config does not point to monkeysphere authorized keys."
+       echo " - Recommendation: add a line to $sshd_config: 'AuthorizedKeysFile ${SYSDATADIR}/authorized_keys/%u'"
+       problemsfound=$(($problemsfound+1))
+    fi
+    if badauthorizedkeys=$(grep -i '^AuthorizedKeysFile' "$sshd_config" | grep -v "^AuthorizedKeysFile[[:space:]]\+${SYSDATADIR}/authorized_keys/%u$") ; then
+       echo "! $sshd_config refers to non-monkeysphere authorized_keys files:"
+       echo "$badauthorizedkeys"
+       echo " - Recommendation: remove the above AuthorizedKeysFile lines from $sshd_config"
+       problemsfound=$(($problemsfound+1))
+    fi
+
+    if [ "$problemsfound" -gt 0 ]; then
+       echo "When the above $problemsfound issue"$(if [ "$problemsfound" -eq 1 ] ; then echo " is" ; else echo "s are" ; fi)" resolved, please re-run:"
+       echo "  monkeysphere-server diagnostics"
+    else
+       echo "Everything seems to be in order!"
+    fi
 }
 
 # retrieve key from web of trust, import it into the host keyring, and
@@ -491,7 +726,7 @@ add_certifier() {
     depth=1
 
     # get options
-    TEMP=$(getopt -o n:t:d: -l domain:,trust:,depth: -n "$PGRM" -- "$@")
+    TEMP=$(PATH="/usr/local/bin:$PATH" getopt -o n:t:d: -l domain:,trust:,depth: -n "$PGRM" -- "$@") || failure "getopt failed!  Does your getopt support GNU-style long options?"
 
     if [ $? != 0 ] ; then
        exit 1
@@ -525,35 +760,66 @@ add_certifier() {
 
     keyID="$1"
     if [ -z "$keyID" ] ; then
-       failure "You must specify the key ID of a key to add."
+       failure "You must specify the key ID of a key to add, or specify a file to read the key from."
+    fi
+    if [ -f "$keyID" ] ; then
+       echo "Reading key from file '$keyID':"
+       importinfo=$(gpg_authentication "--import" < "$keyID" 2>&1) || failure "could not read key from '$keyID'"
+       # FIXME: if this is tried when the key database is not
+       # up-to-date, i got these errors (using set -x):
+
+# ++ su -m monkeysphere -c '\''gpg --import'\''
+# Warning: using insecure memory!
+# gpg: key D21739E9: public key "Daniel Kahn Gillmor <dkg@fifthhorseman.net>" imported
+# gpg: Total number processed: 1
+# gpg:               imported: 1  (RSA: 1)
+# gpg: can'\''t create `/var/monkeysphere/gnupg-host/pubring.gpg.tmp'\'': Permission denied
+# gpg: failed to rebuild keyring cache: Permission denied
+# gpg: 3 marginal(s) needed, 1 complete(s) needed, PGP trust model
+# gpg: depth: 0  valid:   1  signed:   0  trust: 0-, 0q, 0n, 0m, 0f, 1u
+# gpg: next trustdb check due at 2009-01-10'
+# + failure 'could not read key from '\''/root/dkg.gpg'\'''
+# + echo 'could not read key from '\''/root/dkg.gpg'\'''
+
+       keyID=$(echo "$importinfo" | grep '^gpg: key ' | cut -f2 -d: | cut -f3 -d\ )
+       if [ -z "$keyID" ] || [ $(echo "$keyID" | wc -l) -ne 1 ] ; then
+           failure "Expected there to be a single gpg key in the file."
+       fi
+    else
+        # get the key from the key server
+       gpg_authentication "--keyserver $KEYSERVER --recv-key '0x${keyID}!'" || failure "Could not receive a key with this ID from the '$KEYSERVER' keyserver."
     fi
+
     export keyID
 
-    # get the key from the key server
-    gpg_authentication "--keyserver $KEYSERVER --recv-key '$keyID'"
 
     # get the full fingerprint of a key ID
-    fingerprint=$(gpg_authentication "--list-key --with-colons --with-fingerprint $keyID" | \
+    fingerprint=$(gpg_authentication "--list-key --with-colons --with-fingerprint 0x${keyID}!" | \
        grep '^fpr:' | grep "$keyID" | cut -d: -f10)
 
+    if [ -z "$fingerprint" ] ; then
+       failure "Key '$keyID' not found."
+    fi
+
+    echo
     echo "key found:"
-    gpg_authentication "--fingerprint $fingerprint"
+    gpg_authentication "--fingerprint 0x${fingerprint}!"
 
-    echo "Are you sure you want to add this key as a certifier of"
-    read -p "users on this system? (y/N) " OK; OK=${OK:-N}
+    echo "Are you sure you want to add the above key as a"
+    read -p "certifier of users on this system? (y/N) " OK; OK=${OK:-N}
     if [ "${OK/y/Y}" != 'Y' ] ; then
-       failure "aborting."
+       failure "Identity certifier not added."
     fi
 
     # export the key to the host keyring
-    gpg_authentication "--export $keyID" | gpg_host --import
+    gpg_authentication "--export 0x${fingerprint}!" | gpg_host --import
 
     if [ "$trust" == marginal ]; then
        trustval=1
     elif [ "$trust" == full ]; then
        trustval=2
     else
-       failure "trust value requested ('$trust') was unclear (only 'marginal' or 'full' are supported)"
+       failure "Trust value requested ('$trust') was unclear (only 'marginal' or 'full' are supported)."
     fi
 
     # ltsign command
@@ -570,10 +836,17 @@ EOF
        )
 
     # ltsign the key
-    echo "$ltsignCommand" | gpg_host --quiet --command-fd 0 --edit-key "$fingerprint"
+    if echo "$ltsignCommand" | \
+       gpg_host --quiet --command-fd 0 --edit-key "0x${fingerprint}!" ; then
+
+        # update the trustdb for the authentication keyring
+       gpg_authentication "--check-trustdb"
 
-    # update the trustdb for the authentication keyring
-    gpg_authentication "--check-trustdb"
+       echo
+       echo "Identity certifier added."
+    else
+       failure "Problem adding identify certifier."
+    fi
 }
 
 # delete a certifiers key from the host keyring
@@ -586,16 +859,43 @@ remove_certifier() {
        failure "You must specify the key ID of a key to remove."
     fi
 
-    # delete the requested key (with prompting)
-    gpg_host --delete-key "$keyID"
+    if gpg_authentication "--no-options --list-options show-uid-validity --keyring ${GNUPGHOME_AUTHENTICATION}/pubring.gpg --list-key 0x${keyID}!" ; then
+       read -p "Really remove above listed identity certifier? (y/N) " OK; OK=${OK:-N}
+       if [ "${OK/y/Y}" != 'Y' ] ; then
+           failure "Identity certifier not removed."
+       fi
+    else
+       failure
+    fi
+
+    # delete the requested key
+    if gpg_authentication "--delete-key --batch --yes 0x${keyID}!" ; then
+       # delete key from host keyring as well
+       gpg_host --delete-key --batch --yes "0x${keyID}!"
 
-    # update the trustdb for the authentication keyring
-    gpg_authentication "--check-trustdb"
+        # update the trustdb for the authentication keyring
+       gpg_authentication "--check-trustdb"
+
+       echo
+       echo "Identity certifier removed."
+    else
+       failure "Problem removing identity certifier."
+    fi
 }
 
 # list the host certifiers
 list_certifiers() {
-    gpg_host --list-keys
+    local keys
+    local key
+
+    # find trusted keys in authentication keychain
+    keys=$(gpg_authentication "--no-options --list-options show-uid-validity --keyring ${GNUPGHOME_AUTHENTICATION}/pubring.gpg --list-keys --with-colons --fingerprint" | \
+        grep ^pub: | cut -d: -f2,5 | egrep '^(u|f):' | cut -d: -f2)
+
+    # output keys
+    for key in $keys ; do
+        gpg_authentication "--no-options --list-options show-uid-validity --keyring ${GNUPGHOME_AUTHENTICATION}/pubring.gpg --list-key --fingerprint $key"
+    done
 }
 
 # issue command to gpg-authentication keyring
@@ -614,25 +914,27 @@ unset RAW_AUTHORIZED_KEYS
 unset MONKEYSPHERE_USER
 
 # load configuration file
-[ -e ${MONKEYSPHERE_SERVER_CONFIG:="${ETC}/monkeysphere-server.conf"} ] && . "$MONKEYSPHERE_SERVER_CONFIG"
+[ -e ${MONKEYSPHERE_SERVER_CONFIG:="${SYSCONFIGDIR}/monkeysphere-server.conf"} ] && . "$MONKEYSPHERE_SERVER_CONFIG"
 
 # set empty config variable with ones from the environment, or with
 # defaults
+LOG_LEVEL=${MONKEYSPHERE_LOG_LEVEL:=${LOG_LEVEL:="INFO"}}
 KEYSERVER=${MONKEYSPHERE_KEYSERVER:=${KEYSERVER:="subkeys.pgp.net"}}
-AUTHORIZED_USER_IDS=${MONKEYSPHERE_AUTHORIZED_USER_IDS:=${AUTHORIZED_USER_IDS:="%h/.config/monkeysphere/authorized_user_ids"}}
+AUTHORIZED_USER_IDS=${MONKEYSPHERE_AUTHORIZED_USER_IDS:=${AUTHORIZED_USER_IDS:="%h/.monkeysphere/authorized_user_ids"}}
 RAW_AUTHORIZED_KEYS=${MONKEYSPHERE_RAW_AUTHORIZED_KEYS:=${RAW_AUTHORIZED_KEYS:="%h/.ssh/authorized_keys"}}
 MONKEYSPHERE_USER=${MONKEYSPHERE_MONKEYSPHERE_USER:=${MONKEYSPHERE_USER:="monkeysphere"}}
 
 # other variables
 CHECK_KEYSERVER=${MONKEYSPHERE_CHECK_KEYSERVER:="true"}
 REQUIRED_USER_KEY_CAPABILITY=${MONKEYSPHERE_REQUIRED_USER_KEY_CAPABILITY:="a"}
-GNUPGHOME_HOST=${MONKEYSPHERE_GNUPGHOME_HOST:="${VARLIB}/gnupg-host"}
-GNUPGHOME_AUTHENTICATION=${MONKEYSPHERE_GNUPGHOME_AUTHENTICATION:="${VARLIB}/gnupg-authentication"}
+GNUPGHOME_HOST=${MONKEYSPHERE_GNUPGHOME_HOST:="${SYSDATADIR}/gnupg-host"}
+GNUPGHOME_AUTHENTICATION=${MONKEYSPHERE_GNUPGHOME_AUTHENTICATION:="${SYSDATADIR}/gnupg-authentication"}
 
 # export variables needed in su invocation
 export DATE
 export MODE
 export MONKEYSPHERE_USER
+export LOG_LEVEL
 export KEYSERVER
 export CHECK_KEYSERVER
 export REQUIRED_USER_KEY_CAPABILITY
@@ -654,11 +956,23 @@ case $COMMAND in
        gen_key "$@"
        ;;
 
-    'show-fingerprint'|'f')
-       fingerprint_server_key
+    'extend-key'|'e')
+       extend_key "$@"
+       ;;
+
+    'add-hostname'|'add-name'|'n+')
+       add_hostname "$@"
+       ;;
+
+    'revoke-hostname'|'revoke-name'|'n-')
+       revoke_hostname "$@"
+       ;;
+
+    'show-key'|'show'|'s')
+       show_server_key
        ;;
 
-    'publish-key'|'p')
+    'publish-key'|'publish'|'p')
        publish_server_key
        ;;
 
@@ -666,15 +980,15 @@ case $COMMAND in
        diagnostics
        ;;
 
-    'add-identity-certifier'|'add-certifier'|'a')
-       add_certifier "$1"
+    'add-identity-certifier'|'add-id-certifier'|'add-certifier'|'c+')
+       add_certifier "$@"
        ;;
 
-    'remove-identity-certifier'|'remove-certifier'|'r')
-       remove_certifier "$1"
+    'remove-identity-certifier'|'remove-id-certifier'|'remove-certifier'|'c-')
+       remove_certifier "$@"
        ;;
 
-    'list-identity-certifiers'|'list-certifiers'|'list-certifier'|'l')
+    'list-identity-certifiers'|'list-id-certifiers'|'list-certifiers'|'list-certifier'|'c')
        list_certifiers "$@"
        ;;
 
@@ -682,7 +996,7 @@ case $COMMAND in
        gpg_authentication_cmd "$@"
        ;;
 
-    'help'|'h'|'?')
+    '--help'|'help'|'-h'|'h'|'?')
         usage
         ;;